\input{../common/common.tex}

%
% Homework Title
% Renew:
%   - Title
%   - Due date
% Fixed:
%   - Class
%   - Section/Time
%   - Instructor
%   - Author
%

\renewcommand{\hmwkTitle}{Exercise\ \#5}
\renewcommand{\hmwkDueDate}{July 13, 2020}

%
% Document
%

\begin{document}
\maketitle \newpage

\section{Introduction}
\label{sec:introduction}

\textbf{Note:} during writing, my bibtex biber backend failed. For the links to
the references \cite{2013a} \cite{2013b} \cite{2018} mentioned here, refer to
the \texttt{README.md}.

A simple version of the domain decomposition Conductor-like Screening Model
(ddCOSMO) was implemented in MATLAB, using the references \cite{2013a}
\cite{2013b} \cite{2018}. COSMO models assume the solvent to be an ideal
conductor. This simplifies the more general Linearised Poisson-Boltzmann
equation and its solution considerably, trading accuracy for it. ddCOSMO
rewrites the COSMO PDE for the reaction potential \(W\) with \(M = \) number of
atoms -- coupled problems \cite{2018} eqn.s (1) - (3). The discretization of
this yields the linear system \(L X = g\). From the vector \(X\), the solvation
energy \(E_s\) of the molecule can be computed.  

The implementation presented here builds the ddCOSMO linear system \(L X = g\).
The matrix \(L\) is square, non-symmetric, block-sparse, with sidelength \(M
b\), where \(b = (lmax+1)^2\) is the block size. The implementation builds \(L\)
as dense matrix for sake of short development time. The solver receives it as
sparse matrix and solves the system with MATLAB's builtin restarted GMRES
solver. \(\frac{M b}{2}\) was found to be a good restart parameter for
guaranteed convergence.

The implementation computes the solvation energy \(E_s\) from vector \(X\) using
only its \((l,m)=(0,0)\) entries, i.e. \(\left[X_j\right]_0^0\), according to
\cite{2013a} eqn. (21) for \(E_s\), which assumes ddCOSMO to be coupled to a
classical MM code \cite{2018} eqn. (33), which was not done here. Instead, we
use molecule's atom charges to be the charges \(q_j\) in the equation, and we
use them before as well to compute the free space potential according to
\cite{2018} eqn. (32).


\section{Test molecules}
\label{sec:test-molecules}

Visualizations with VMD, vdW radius scaling=1. Note: for the first three
molecules, the visualization seems not right: the vdW balls in 2spheres and
3spheres intersect in reality, while those in 3spheres\_2 do not. 

\begin{figure}[H] %[htb!]
    \centering
    \includegraphics[width=0.2\linewidth]{vmd/2spheres.png} % = {../img/dummy.png}
    \caption{Molecule 2spheres.pdb}
    \label{fig:vmd_2spheres}
\end{figure}

For minimal \texttt{lebedev\_degree=6}, 2spheres has one intersection point,
i.e. each atom is the other's single neighbor. This served as a nice test case during early development, see folder
\texttt{src/dev}.

\begin{figure}[H] %[htb!]
    \centering
    \includegraphics[width=0.2\linewidth]{vmd/3spheres.png} % = {../img/dummy.png}
    \caption{Molecule 3spheres.pdb}
    \label{fig:vmd_3spheres}
\end{figure}

\begin{figure}[H] %[htb!]
    \centering
    \includegraphics[width=0.2\linewidth]{vmd/3spheres_2.png} % = {../img/dummy.png}
    \caption{Molecule 3spheres\_2.pdb. Ghost image: molecule 3spheres.pdb}
    \label{fig:vmd_3spheres_2}
\end{figure}

3spheres\_2 is the only molecule with no intersections, i.e. no neighbors. This
also served as a nice test case during early development.

\begin{figure}[H] %[htb!]
    \centering
    \includegraphics[width=0.2\linewidth]{vmd/benzene.png} % = {../img/dummy.png}
    \caption{Molecule benzene.pdb}
    \label{fig:vmd_benzene}
\end{figure}

For benzene and caffeine, \cite{2013b} TABLE II. offers some ddCOSMO solvation
energies for comparison with the results presented here.

\begin{figure}[H] %[htb!]
    \centering
    \includegraphics[width=0.2\linewidth]{vmd/caffeine.png} % = {../img/dummy.png}
    \caption{Molecule caffeine.pdb}
    \label{fig:vmd_caffeine}
\end{figure}

\section{Results}
\label{sec:results}

We ran the solver with the following input parameters:

\begin{itemize}
\item molecules: 2spheres, 3spheres, 3spheres\_2, benzene, caffeine.
\item \texttt{lmax}: 0, 1, recommended value \cite{2018} TABLE 1: 6.
\item \texttt{lebedev\_degree}: 6, 6, recommended value \cite{2018} TABLE 1: 110.
\end{itemize}

In the following, we will present the full output of the solver only once for the
first simulation. For the subsequent simulations with exceptions, we only
present the solvation energy. 

\subsection{2spheres}
\label{sec:2spheres}

% Some code.
\lstinputlisting[
language={},
style=code,
%linerange=1-1,
captionpos=t,
caption={2spheres, lmax=0, lebedev=6},
label=lst-that,
]{../txt/2spheres_lmax0_lebedev6.txt}

2spheres, lmax=1, lebedev=6:
\begin{verbatim}
Solution:
---------
Solver output statistics:
  length(X)=8, filling factor(L)=0.250, sum(X)=-6.498e-01, sum(g)=-6.804e+00
  time_build_system=0.174 s, time_solve_system=0.031 s
Solvation energy:
  E_solvation_ref_2013a = -1.130e+00 au
  E_solvation_ref_2018_naive = -3.403e-17 au
\end{verbatim}

\subsection{3spheres}
\label{sec:3spheres}

3spheres, lmax=0, lebedev=6:
\begin{verbatim}
Solution:
---------
Solver output statistics:
  length(X)=3, filling factor(L)=1.000, sum(X)=-1.310e+00, sum(g)=-1.189e+01
  time_build_system=0.189 s, time_solve_system=0.037 s
Solvation energy:
  E_solvation_ref_2013a = -2.278e+00 au
  E_solvation_ref_2018_naive = 000 au
\end{verbatim}

3spheres, lmax=1, lebedev=6:
\begin{verbatim}
Solution:
---------
Solver output statistics:
  length(X)=12, filling factor(L)=0.250, sum(X)=-1.284e+00, sum(g)=-1.026e+01
  time_build_system=0.216 s, time_solve_system=0.070 s
Solvation energy:
  E_solvation_ref_2013a = -2.270e+00 au
  E_solvation_ref_2018_naive = 1.039e-02 au
\end{verbatim}

3spheres\_2 (no neighbors), lmax=1, lebedev=6:
\begin{verbatim}
Solution:
---------
Solver output statistics:
  length(X)=12, filling factor(L)=0.083, sum(X)=-9.800e-01, sum(g)=-1.232e+01
  time_build_system=0.151 s, time_solve_system=0.029 s
Solvation energy:
  E_solvation_ref_2013a = -1.704e+00 au
  E_solvation_ref_2018_naive = 000 au
\end{verbatim}

\subsection{benzene}
\label{sec:benzene}

benzene, lmax=0, lebedev=6
\begin{verbatim}
Solution:
---------
Solver output statistics:
  length(X)=12, filling factor(L)=0.556, sum(X)=-5.025e+01, sum(g)=-2.217e+02
  time_build_system=0.289 s, time_solve_system=0.060 s
Solvation energy:
  E_solvation_ref_2013a = -3.128e+02 au
  E_solvation_ref_2018_naive = 000 au
\end{verbatim}

benzene, lmax=1, lebedev=6
\begin{verbatim}
Solution:
---------
Solver output statistics:
  length(X)=48, filling factor(L)=0.158, sum(X)=-4.729e+01, sum(g)=-2.217e+02
  time_build_system=0.394 s, time_solve_system=0.071 s
Solvation energy:
  E_solvation_ref_2013a = -3.031e+02 au
  E_solvation_ref_2018_naive = 4.505e+00 au
\end{verbatim}

\lstinputlisting[
language={},
style=code,
% linerange=1-1,
captionpos=t,
caption={benzene, lmax=6, lebedev=110},
label=lst-that,
]{../txt/benzene_lmax6_lebedev110.txt}

\subsection{caffeine}
\label{sec:caffeine}

caffeine, lmax=0, lebedev=6:
\begin{verbatim}
Solution:
---------
Solver output statistics:
  length(X)=24, filling factor(L)=0.302, sum(X)=-1.804e+02, sum(g)=-5.049e+02
  time_build_system=0.555 s, time_solve_system=0.077 s
Solvation energy:
  E_solvation_ref_2013a = -1.348e+03 au
  E_solvation_ref_2018_naive = 000 au
\end{verbatim}

caffeine, lmax=1, lebedev=6:
\begin{verbatim}
Solution:
---------
Solver output statistics:
  length(X)=96, filling factor(L)=0.090, sum(X)=-1.601e+02, sum(g)=-5.138e+02
  time_build_system=0.816 s, time_solve_system=0.070 s
Solvation energy:
  E_solvation_ref_2013a = -1.264e+03 au
  E_solvation_ref_2018_naive = 2.478e+01 au
\end{verbatim}

\lstinputlisting[
language={},
style=code,
% linerange=1-1,
captionpos=t,
caption={caffeine, lmax=6, lebedev=110},
label=lst-that,
]{../txt/caffeine_lmax6_lebedev110.txt}

\section{Discussion}
\label{sec:discussion}

The values for solvation energy \(E_s\) do not agree with the ones presented in
reference \cite{2013b} TABLE II for caffeine. In fact they are roughly 6 orders
of magnitude (OM) too large. This is consistent for all presented values of lmax
and lebedev\_degree. This comparison assumes that both result sources use atomic
units, i.e. Hartree as energy unit. Our implementation of \cite{2013a} eqn. (21)
for \(E_s\) assumes water as solvent for the scaling factor \(f(\varepsilon_s\),
but that factor is nearly one anyway.

We tried a different solution for the solvation energy (called
\texttt{E\_solvation\_ref\_2018\_naive} above). This sums over \emph{all}
\(\left[X_j\right]_l^m\) elements of solution vector \(X\), multiplying each
with correspondent atom charge \(q_j\). This is motivated by \cite{2018} p.3/15
eqn. for \(E_S^N\), where we assumed \(\left[\Psi_j\right]_l^m = q_j\), which is
not really correct. It is two OM smaller, but still four OM too large.
\emph{Still}, for the simplest case 2spheres lmax=0 lebedev=6, the values in the
linear system look reasonable.

Regarding timings, it can be clearly seen that \emph{building} the linear system
takes much more time than solving it. The timings table below shows that the
GMRES solver is nearly invariant to the molecule size, while the builder scales
like \(\mathcal{O}(M^2)\). But ddCOSMO should scale linearly. So building the
matrix as dense is not recommended, even though zero-blocks are skipped.
Instead, computing and solving the linear system on the fly as \cite{2013b}
describes is mandatory for efficiency.  

\begin{table}[htb!]
    \centering
    \begin{tabular}{ll|cc}
      molecule & atoms & time build & time solve\\\hline
      3spheres & 3 & 1.799 & 0.041 \\
      benzen & 12 & 23.924 & 0.050 \\
      caffeine & 24 & 77.560 & 0.056 \\
    \end{tabular}
    \caption{timings for lmax=6, lebedev=110}
    \label{tab:timings}
\end{table}


% \section{Do That}
% \label{sec:do-that}

% \begin{formal}
%     This is the task description: Do that.
% \end{formal}

% \subsection{That}
% \label{sec:sketch}

% That is that.

% % An image.
% \begin{figure}[H] %[htb!]
%     \centering
%     \includegraphics[width=0.2\linewidth]{dummy.png} % = {../img/dummy.png}
%     \caption{This.}
%     \label{fig:that}
% \end{figure}

% % A figure.
% \begin{figure}[H] %[htb!]
%     \centering
%     \input{../fig/dummy.tikz}    
%     \caption{That.}
% \end{figure}

% % Some code.
% \lstinputlisting[
% language=python,
% style=code,
% linerange=1-4,
% captionpos=t,
% caption={That.},
% label=lst-that
% ]{../code/dummy.py}


\printbibliography
\end{document}



%%% Local Variables:
%%% mode: latex
%%% TeX-master: t
%%% End:
